Codeforces837D

来源:互联网 发布:事情正在起变化 知乎 编辑:程序博客网 时间:2024/05/16 01:49

D. Round Subset
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Let's call the roundness of the number the number of zeros to which it ends.

You have an array of n numbers. You need to choose a subset of exactly k numbers so that the roundness of the product of the selected numbers will be maximum possible.

Input

The first line contains two integer numbers n and k (1 ≤ n ≤ 200, 1 ≤ k ≤ n).

The second line contains n space-separated integer numbers a1, a2, ..., an (1 ≤ ai ≤ 1018).

Output

Print maximal roundness of product of the chosen subset of length k.

Examples
input
3 250 4 20
output
3
input
5 315 16 3 25 9
output
3
input
3 39 77 13
output
0
Note

In the first example there are 3 subsets of 2 numbers. [50, 4] has product 200 with roundness 2[4, 20] — product 80roundness 1[50, 20] — product 1000roundness 3.

In the second example subset [15, 16, 25] has product 6000roundness 3.

In the third example all subsets has product with roundness 0.


【题意】

给出n个数,让你从中选出k个数,使得它们乘积的后缀0最多,输出这个值。


【思路】


显然0是由2*5得来的,所以先算出一个数分解质因子后2和5的个数。


然后用dp[i][j]表示选择了i个数,且这i个数质因子中5的个数和为j时,质因子中2的个数和的最大值。状态转移方程为:


dp[j][l]=max(dp[j][l],dp[j-1][l-n5]+n2);


#include<bits/stdc++.h>using namespace std;#define LL long long#define N 205int n, k, dp[N][6000];int two[N], five[N];void solve(){    memset(two, 0, sizeof(two));    memset(five, 0, sizeof(five));    memset(dp, 0xbf, sizeof(dp));    int tf=0;    for(int i=1; i<=n; i++)    {        LL x, tmp;cin>>x;tmp=x;        while(x%2==0)        {            two[i]++;            x/=2;        }        x=tmp;        while(x%5==0)        {            five[i]++;            x/=5;            tf++;        }    }    dp[0][0] = 0;    int ans = 0;    for(int i=1; i<=n; i++)        for(int j = min(k, i); j >= 1; j--)            for(int k = tf; k >= five[i]; k--)                dp[j][k] = max(dp[j][k], dp[j-1][k-five[i]]+two[i]);    for(int i = 1; i <= tf; i++)        ans = max(ans, min(dp[k][i], i));    cout << ans << endl;}int main(){    while(cin>>n>>k)    {        solve();    }    return 0;}




原创粉丝点击